<!--
// Supported Browsers
var BrowserTypeIE = "Internet Explorer";
var IEMinVersion = 8;
var BrowserTypeFirefox = "Firefox";
var FirefoxMinVersion = "3.6";
var BrowserTypeSafari = "Safari";
var SafariMinVersion = 4;

// Supported Operating Systems
var OSTypeWin = "Microsoft Windows";
var OSTypeMac = "Apple Macintosh";

// Supported Java Version
var JavaMinVerMajor = 1;
var JavaMinVerMinor = 6;
var JavaMinVerBuild = 0;

// Supported Flash Version
var FlashMinVerMajor = 9;
var FlashMinVerMinor = 0;
var FlashMinVerBuild = 0;

var BrowserDetect = {
		init: function () {
			this.browserIsIE = false;
			this.descriptionValue = false;
			// this.browser = this.searchString(this.dataBrowser) || "An unsupported browser";
			this.browser = this.searchString(this.dataBrowser) || -1;
			
			this.version = this.searchVersion(navigator.userAgent)
				|| this.searchVersion(navigator.appVersion)
				|| -1;
				//|| "with an unknown version";
			this.OS = this.searchString(this.dataOS) || null;
			//this.plugins = this.searchPlugin(navigator.plugins);
			this.cookieEnabled = this.checkCookies(navigator.plugins);
			this.flashEnabled = this.checkFlash(navigator.plugins);
			this.browserCheck = this.checkBrowser(this.browser, this.version);
			this.javaEnabled = this.checkJava(navigator.plugins);
		
			//top.frames.hidden.location.href = "vpresent://";
		},
		
		checkCookies: function(data) {
			var tmpcookie = new Date();
			var chkcookie = (tmpcookie.getTime() + '');
			document.cookie = "chkcookie=" + chkcookie + "; path=/";
			var cookieEnabled=(document.cookie && (document.cookie.indexOf(chkcookie) >=0))? true : false;
		
			return cookieEnabled;
		},
		
		checkJava: function (data) {
		    this.descriptionValue = false;
			var description = 'Java is not installed.';
			var support = false;
			if (this.OS != null && this.OS.search(OSTypeMac) >=0) {
				if (navigator.javaEnabled()) {
					this.javaDesc = 'Java is installed.';
					this.descriptionValue = true;
					return true;
				}
			}
			for (var i=0;i<data.length;i++)	{
				var plugin = data[i];
				if((plugin.description.search("Java") >= 0)
					&& (plugin.description.search("Plug-in") >= 0))
				{
					description = plugin.description;
					if((this.OS != null) && (this.OS.search(OSTypeWin) >= 0)) {
						support = this.checkJavaVersion(description);
					}
					break;
				}
			}
			
			this.javaDesc = description;

			return support;
		},
		
		checkJavaVersion: function (dataString) {
			var support = false;
			var strArr = dataString.split(' ');
			var reqJavaVerMajor = JavaMinVerMajor;
			var reqJavaVerMinor = JavaMinVerMinor;
			var reqJavaVerBuild = JavaMinVerBuild;
			var major = 0;
			var minor = 0;
			var build = 0;
			
			if(strArr.length >= 3)
			{
				var version = strArr[2].split('.');
				
				if(version.length >= 3)
				{
					major = parseInt(version[0]);
					minor = parseInt(version[1]);
					// For now, don't care about the build/release version
					// most likely, we won't need precision to the build number
					//build = parseInt(strArr[3]);
					
					if(major > reqJavaVerMajor)
					{
						support = true;
					}
					else if(major == reqJavaVerMajor)
					{
						if(minor >= reqJavaVerMinor)
						{
							support = true;
						}
					}
				}
			}
			
			//var dbgstr = "Major: " + major + " Minor: " + minor + " Build: " + build;
			return support;
		},
		
		checkBrowser: function (browser, version) {
			var support = false;
			
			if (browser.search(BrowserTypeIE) >= 0)
			{
				// Internet Explorer
				this.browserIsIE = true;
				if(version >= IEMinVersion)
				{
					support = true;
				}
			}
			else if (browser.search(BrowserTypeFirefox) >= 0)
			{
				// Firefox
				if(version >= FirefoxMinVersion)
				{
					support = true;
				}
			}
			else if (browser.search(BrowserTypeSafari) >= 0)
			{
				// Safari
				if(version >= SafariMinVersion)
				{
					support = true;
				}
			}
			else
			{
				support = false;
			}
			
			return support;
		},
		
		searchString: function (data) {
			for (var i=0;i<data.length;i++)	{
				var dataString = data[i].string;
				var dataProp = data[i].prop;
				this.versionSearchString = data[i].versionSearch || data[i].identity;
				if (dataString) {
					if (dataString.indexOf(data[i].subString) != -1)
						return data[i].identity;
				}
				else if (dataProp)
					return data[i].identity;
			}
		},
		
		searchVersion: function (dataString) {
			var index = dataString.indexOf(this.versionSearchString);
			if (index == -1) return;
			return parseFloat(dataString.substring(index+this.versionSearchString.length+1));
		},
		
		searchPlugin: function (data) {
			var plugins = "<br>";
			for (var i=0;i<data.length;i++)	{
				plugins += "<b>" + data[i].name + "</b><br>";
				for(prop in data[i])
				{
					plugins += prop + " value :" + data[i][prop]+ "<br>";
				}
			}
			
			return plugins;
		},
		
		checkFlash: function (data) {
			var description = 'Flash is not installed.';
			var support = false;
			
			for (var i=0;i<data.length;i++)	{
				var plugin = data[i];
				if(plugin.name.search("Flash") >= 0)
				{
					description = plugin.description;
					support = this.checkFlashVersion(description);
					break;
				}
			}
			
			this.flashDesc = description;
			return support;
		},
		
		checkFlashVersion: function (dataString) {
			var support = false;
			var strArr = dataString.split(' ');
			var reqFlashVerMajor = FlashMinVerMajor;
			var reqFlashVerMinor = FlashMinVerMinor;
			var reqFlashVerBuild = FlashMinVerBuild;
			var major = 0;
			var minor = 0;
			var build = 0;
			
			if(strArr.length >= 4)
			{
				var version = strArr[2].split('.');
				
				if(version.length >= 2)
				{
					major = parseInt(version[0]);
					minor = parseInt(version[1]);
					// For now, don't care about the build/release version
					// most likely, we won't need precision to the build number
					//build = parseInt(strArr[3]);
					
					if(major > reqFlashVerMajor)
					{
						support = true;
					}
					else if(major == reqFlashVerMajor)
					{
						if(minor >= reqFlashVerMinor)
						{
							support = true;
						}
					}
				}
			}
			
			//var dbgstr = "Major: " + major + " Minor: " + minor + " Build: " + build;
			return support;
		},
		
		checkWinVpresent: function () {
			var shell;
			var vpresentVersion = "none";
			try {
				shell = new ActiveXObject("WScript.Shell");

				if (shell != null) {
					try {
						vpresentVersion = shell.regRead("HKEY_CURRENT_USER\\Software\\VPresent\\VPresent\\VersionChecked");
					} catch(e) {
						vpresentVersion="error";
					}
				}
			} catch(e) {
				vpresentVersion="error";
			}
		},
		
		dataBrowser: [
		{
			string: navigator.vendor,
			subString: "Apple",
			identity: BrowserTypeSafari,
			versionSearch: "Version"
		},
		{
			string: navigator.userAgent,
			subString: "Firefox",
			identity: BrowserTypeFirefox
		},
		{
			string: navigator.userAgent,
			subString: "MSIE",
			identity: BrowserTypeIE,
			versionSearch: "MSIE"
		},
	],
	
	dataOS : [
		{
			string: navigator.platform,
			subString: "Win",
			identity: OSTypeWin
		},
		{
			string: navigator.platform,
			subString: "Mac",
			identity: OSTypeMac
		},
	]
};
-->