# -*- coding: utf8 -*-
# parse wc2.php localization file:
# a.  remove the BOM char
# b.  change "*\"foo\"*" -> "*“foo”*"
# c.  change "*'*"        ->"*’*"
#
# wc2.php entry
#
# $gltext['6a26f548831e6a8c26bfbbd9f6ec61e0']="Aide";
# //_State: Existing
# //_Orginal: Help
# //_Source: ./admin.php line: 82
#//_Source: ./includes/common_text.php line: 48
#
# NOTE: This is NOT a general php file parser.
# just for wc2.php code pattern.
# 

import cStringIO
import sys
import os
import string

def short_filename(filename):
    cwd = os.getcwd()
    ifile = filename.find(cwd)
    if ifile >= 0:
       shortfile = filename[len(cwd):]
    else:
       shortfile = filename

    return shortfile


# parse state
# 0 = none
# 1 = waiting for close \"

def parse_translation(code,i,parsestate,filechanged):

    # look for \" and '

    c1 = code[i]
    c2 = code[i:i + 2]
    di = 0

    if c1.find("'",0) == 0:
            t1 = "’"
            filechanged = 1
            di = 1
    elif parsestate == 0:
        if c2.find("\\\"",0) == 0:
            print "found open quote"
            t1 = "“"
            parsestate = 1
            filechanged = 1
            di = 2            
        else:
            t1 = c1
    elif parsestate == 1:
        if c2.find("\\\"",0) == 0:
            t1 = "”"
            parsestate = 0
            filechanged = 1
            di = 2
        else:
            t1 = c1
    else:
        print 'syntax error'
                
    return t1,parsestate,filechanged,di

def read_till(code,i, c):

    line = []
    while code[i] != c:
        line.append(code[i])
        i = i + 1
        # end while loop
        
    line.append(c)
    
    t1 = "".join(line) 

    return t1

def filter_file(filename,key1,key2):
   # Get the Data
    strbuf = cStringIO.StringIO()

    infile = open(filename,"r")
    shortname = short_filename(filename)

    print "processing file:", shortname , " ..."
    
    while infile:
        line = infile.readline()
        if line != "" :
            strbuf.write(line)
        else:
            break

    infile.close()

    code = strbuf.getvalue()

    gltext1 = "$gltext["
    lgltext1 = len(gltext1)
    gltext2 = "]="
    lgltext2 = len(gltext2)
    endquote = '";'
    lendquote = len(endquote)
    
    # parse states:
    # 0 - waiting for  gltext[
    # 1 - waiting for  ]="
    # 2 - wait for end ";

    state = 0
    oldstate =0
    parsestate =0
    oldparsestate = 0

    i=0
    clen = len(code)

    filechanged = 0
    newcode = []

    # deal with the BOM
    
    if ord(code[0]) == 239 and ord(code[1]) == 187 and ord(code[2]) == 191:
        print 'FATAL ERROR: Found BOM chars, removing them'
        filechanged = 1
        i = 3

    line = 0
    curline = []
    while i< clen:        
        di  = 0

        if code[i] == "\n":
            line = line + 1
            curline = []

        if state != oldstate:
            print 'new state:', state

        if parsestate != oldparsestate:
            print 'new parsestate:', parsestate

        # wait for 'gltext['
        if state == 0:
            t1 = code[i:i + lgltext1]
            comment = code[i: i + 2]
            if comment == '//':
                # read till end of line
                t1 = read_till(code, i, "\n")
                line += 1
            elif t1.find(gltext1,0) == 0:
                state = state + 1
            else:
                t1 = code[i]
        # wait for open "
        elif state == 1:
            t1 = code[i:i + lgltext2]
            if t1.find(gltext2,0) == 0:
                state = state + 1
                parsestate = 0
            else:
                t1 = code[i]
        # wait for close ";
        elif state == 2:
            t1 = code[i:i + lendquote]
            if t1.find(endquote,0) == 0:
                state = 0
                if parsestate == 1:
                    print "syntax error: open quote with out a close at ", filename,"(",line + 1,")"
                    print "".join(curline)
                    exit(0)
                parsestate = 0
            else:
                t1,parsestate,filechanged,di = parse_translation(code,i,parsestate,filechanged)

        oldstate = state
        oldparsestate = parsestate
        
        # save new code
        newcode.append(t1)
        curline.append(t1)

        if (di == 0):
            i = i + len(t1)
        else:
            i = i + di
        # end of while loop

    # new code str
    outstr = "".join(newcode)

    # replace key1 for key2
    if (key1 == "0" and key2 == "0"):
       print "  no keys to replace..."
    else:
       print "  replacing key", key1, " for ", key2, " ..."
       newoutstr =  outstr.replace(key1,key2,1)
       if newoutstr != outstr:
           filechanged = 1
           outstr = newoutstr

    # write new file
    if filechanged:
        try:        
            outfile = open(filename,"w")
            print "  updating new file..."
            outfile.write(outstr)
            outfile.close()
        except:
            print 'COLLAB ONLY A FLESH WOUND WARNING: locale_me file needs updating'
    else:
        print "  file not changed"
    
    return 0
    

def filter_recursively(key1,key2):
    curdir = os.getcwd()
    for root,dirs,files in os.walk(curdir):
       for f in files:
           path = os.path.join(root,f)
           if f == "wc2.php" :
               filter_file(path,key1,key2)
    return 0
    #end filter_recursively()
    
# read args
argc = len(sys.argv)

if argc  > 1:
    arg1 = sys.argv[1]

    if argc == 4:
        key1 = sys.argv[2]
        key2 = sys.argv[3]
    else:
        key1 = "0"
        key2 = "0"

    print "key1 = ", key1
    print "key2 = ", key2
    
    if (arg1 == "-r"):
        print "recursively find all wc2.php files ..."
        filter_recursively(key1,key2)
    else:
        filter_file(sys.argv[1],key1,key2)

    print "done"        
else:
    print "usage: "
    print "to filter the wc2.php file in the cur dir: "
    print "  locale_me.py <wc2.php> <key1> <key2>"
    print ""
    print "to recursively filter all wc2.php files in the current dir:"
    print "  locale_me.py -r <key1> <key2>"

